import{s as tt,f as O,n as et,o as it}from"../chunks/scheduler.37c15a92.js";import{S as at,i as nt,g as n,s,r as st,A as lt,h as l,f as i,c as r,j as Z,u as rt,x as c,k as u,y as ot,a,v as ct,d as ut,t as pt,w as mt}from"../chunks/index.7cb9c9b8.js";import{H as gt}from"../chunks/Heading.d3928e2a.js";function ht(U){let o,M,y,H,p,P,m,W="In RL, we build an agent that can <strong>make smart decisions</strong>. For instance, an agent that <strong>learns to play a video game.</strong> Or a trading agent that <strong>learns to maximize its benefits</strong> by deciding on <strong>what stocks to buy and when to sell.</strong>",k,g,F,$,h,V="To make intelligent decisions, our agent will learn from the environment by <strong>interacting with it through trial and error</strong> and receiving rewards (positive or negative) <strong>as unique feedback.</strong>",C,f,B="Its goal <strong>is to maximize its expected cumulative reward</strong> (because of the reward hypothesis).",R,d,D="<strong>The agent’s decision-making process is called the policy π:</strong> given a state, a policy will output an action or a probability distribution over actions. That is, given an observation of the environment, a policy will provide an action (or multiple probabilities for each action) that the agent should take.",q,v,J,A,_,K="<strong>Our goal is to find an optimal policy π* </strong>, aka., a policy that leads to the best expected cumulative reward.",z,w,N="And to find this optimal policy (hence solving the RL problem), there <strong>are two main types of RL methods</strong>:",I,L,Q="<li><em>Policy-based methods</em>: <strong>Train the policy directly</strong> to learn which action to take given a state.</li> <li><em>Value-based methods</em>: <strong>Train a value function</strong> to learn <strong>which state is more valuable</strong> and use this value function <strong>to take the action that leads to it.</strong></li>",j,b,X,E,T,Y="And in this unit, <strong>we’ll dive deeper into the value-based methods.</strong>",G,x,S;return p=new gt({props:{title:"What is RL? A short recap",local:"what-is-rl",headingTag:"h1"}}),{c(){o=n("meta"),M=s(),y=n("p"),H=s(),st(p.$$.fragment),P=s(),m=n("p"),m.innerHTML=W,k=s(),g=n("img"),$=s(),h=n("p"),h.innerHTML=V,C=s(),f=n("p"),f.innerHTML=B,R=s(),d=n("p"),d.innerHTML=D,q=s(),v=n("img"),A=s(),_=n("p"),_.innerHTML=K,z=s(),w=n("p"),w.innerHTML=N,I=s(),L=n("ul"),L.innerHTML=Q,j=s(),b=n("img"),E=s(),T=n("p"),T.innerHTML=Y,G=s(),x=n("p"),this.h()},l(t){const e=lt("svelte-u9bgzb",document.head);o=l(e,"META",{name:!0,content:!0}),e.forEach(i),M=r(t),y=l(t,"P",{}),Z(y).forEach(i),H=r(t),rt(p.$$.fragment,t),P=r(t),m=l(t,"P",{"data-svelte-h":!0}),c(m)!=="svelte-4gdckx"&&(m.innerHTML=W),k=r(t),g=l(t,"IMG",{src:!0,alt:!0}),$=r(t),h=l(t,"P",{"data-svelte-h":!0}),c(h)!=="svelte-1wnqqel"&&(h.innerHTML=V),C=r(t),f=l(t,"P",{"data-svelte-h":!0}),c(f)!=="svelte-1nx2sev"&&(f.innerHTML=B),R=r(t),d=l(t,"P",{"data-svelte-h":!0}),c(d)!=="svelte-1he2m43"&&(d.innerHTML=D),q=r(t),v=l(t,"IMG",{src:!0,alt:!0}),A=r(t),_=l(t,"P",{"data-svelte-h":!0}),c(_)!=="svelte-9qzcpz"&&(_.innerHTML=K),z=r(t),w=l(t,"P",{"data-svelte-h":!0}),c(w)!=="svelte-1fm2b8x"&&(w.innerHTML=N),I=r(t),L=l(t,"UL",{"data-svelte-h":!0}),c(L)!=="svelte-1x976fb"&&(L.innerHTML=Q),j=r(t),b=l(t,"IMG",{src:!0,alt:!0}),E=r(t),T=l(t,"P",{"data-svelte-h":!0}),c(T)!=="svelte-1ywk1bx"&&(T.innerHTML=Y),G=r(t),x=l(t,"P",{}),Z(x).forEach(i),this.h()},h(){u(o,"name","hf:doc:metadata"),u(o,"content",ft),O(g.src,F="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/rl-process.jpg")||u(g,"src",F),u(g,"alt","RL process"),O(v.src,J="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/policy.jpg")||u(v,"src",J),u(v,"alt","Policy"),O(b.src,X="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-approaches.jpg")||u(b,"src",X),u(b,"alt","Two RL approaches")},m(t,e){ot(document.head,o),a(t,M,e),a(t,y,e),a(t,H,e),ct(p,t,e),a(t,P,e),a(t,m,e),a(t,k,e),a(t,g,e),a(t,$,e),a(t,h,e),a(t,C,e),a(t,f,e),a(t,R,e),a(t,d,e),a(t,q,e),a(t,v,e),a(t,A,e),a(t,_,e),a(t,z,e),a(t,w,e),a(t,I,e),a(t,L,e),a(t,j,e),a(t,b,e),a(t,E,e),a(t,T,e),a(t,G,e),a(t,x,e),S=!0},p:et,i(t){S||(ut(p.$$.fragment,t),S=!0)},o(t){pt(p.$$.fragment,t),S=!1},d(t){t&&(i(M),i(y),i(H),i(P),i(m),i(k),i(g),i($),i(h),i(C),i(f),i(R),i(d),i(q),i(v),i(A),i(_),i(z),i(w),i(I),i(L),i(j),i(b),i(E),i(T),i(G),i(x)),i(o),mt(p,t)}}}const ft='{"title":"What is RL? A short recap","local":"what-is-rl","sections":[],"depth":1}';function dt(U){return it(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Lt extends at{constructor(o){super(),nt(this,o,dt,ht,tt,{})}}export{Lt as component};
